#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "zend_API.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "php_ctest.h"

static int le_ctest;

ZEND_NAMED_FUNCTION(dummy) {
  zend_printf("heyho<br>\n");
}

zend_class_entry class1_ce;
zend_function_entry class1_methods[] = {
  ZEND_NAMED_FE(class1, dummy, NULL)
  ZEND_NAMED_FE(c1dummy1, dummy, NULL)
  ZEND_NAMED_FE(c1dummy2, dummy, NULL)
  ZEND_NAMED_FE(c1dummy3, dummy, NULL)
  ZEND_NAMED_FE(c1dummy4, dummy, NULL)
  {NULL, NULL, NULL}
};

zend_class_entry class2_ce;
zend_function_entry class2_methods[] = {
  ZEND_NAMED_FE(c2dummy1, dummy, NULL)
  ZEND_NAMED_FE(c2dummy2, dummy, NULL)
  ZEND_NAMED_FE(c2dummy3, dummy, NULL)
  {NULL, NULL, NULL}
};

zend_class_entry class3_ce;
zend_function_entry class3_methods[] = {
  {NULL, NULL, NULL}
};


zend_module_entry ctest_module_entry = {
  STANDARD_MODULE_HEADER,
  "ctest",
  NULL,
  ZEND_MINIT(ctest),
  ZEND_MSHUTDOWN(ctest),
  ZEND_RINIT(ctest),
  ZEND_RSHUTDOWN(ctest),
  ZEND_MINFO(ctest),
  "0.1",
  STANDARD_MODULE_PROPERTIES
};

#ifdef COMPILE_DL_TEST
ZEND_GET_MODULE(ctest)
#endif

PHP_MINIT_FUNCTION(ctest) {
  INIT_CLASS_ENTRY(class1_ce,"class1",class1_methods);
  zend_register_internal_class(&class1_ce); 
  INIT_CLASS_ENTRY(class2_ce,"class2",class2_methods); 
  zend_register_internal_class_ex(&class2_ce,&class1_ce,"class1");
  INIT_CLASS_ENTRY(class3_ce,"class3",class3_methods); 
  zend_register_internal_class_ex(&class3_ce,&class2_ce,"class2");
  return SUCCESS;
}

PHP_MSHUTDOWN_FUNCTION(ctest) {
  return SUCCESS;
}

PHP_RINIT_FUNCTION(ctest) {
  return SUCCESS;
}

PHP_RSHUTDOWN_FUNCTION(ctest) {
  return SUCCESS;
}

PHP_MINFO_FUNCTION(ctest) {
  php_info_print_table_start();
  php_info_print_table_header(2,"ctest support","enabled");
  php_info_print_table_row(2,"Version","0.1");
  php_info_print_table_end();
  DISPLAY_INI_ENTRIES();
}
